/*
    artifact generator: /wizzi/lib/artifacts/js/module/gen/main.js
    primary source IttfDocument: C:\My\wizzi\v2\sources\wizzi-2-boot\ittf\lib\artifact\artifactInfo.js.ittf
    utc time: Tue, 11 Jul 2017 18:50:00 GMT
*/
'use strict';
// generated by js.module.es2015.module
function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }
var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };


var assert = require('assert');
var path = require('path');
var util = require('util');
var _ = require('lodash');
var verify = require('../util/verify');
var errors = require('../errors');
var fail = require('../util/fail');
var log = require('../util/log')(module)

;
var interpolate = require('../util/interpolate');
var ModelInfo = require("../model/modelinfo").ModelInfo;

/**
     ArtifactInfo is a wrapper around an <artifact> element
     of a <wfjob> WizziModel.
     The config parameter has already been preprocessed
     by the lib/production/wfjob.js module.
     param config:Object {
     name:String,
     options:Object {
     basedir:String // Uri
     dotgExtensionPrefix:Boolean
     },
     model:Object {  // ModelInfo config object
     see lib/production/wfjob.js for creation
     see lib/model/modelInfo.js for use
     },
     isWfJob:Boolean,
     transformers:Array {
     name:String
     dumpFile:String    // Uri
     },
     gen:Object {
     generator:String // generator name
     },
     dest:Object {
     fullpath:String    // Uri
     folder:String      // a basepath Uri, may be relative
     baseFolder:String  // a basepath Uri (required when folder is relative)
     path:String        // relative path
     extension:String
     }
     }
*/

function logme() {
    if (false) {
        console.log.apply(console, arguments);
    }
}


var ArtifactInfo = (function () {
    function ArtifactInfo(config) {
        _classCallCheck(this, ArtifactInfo);
        this.name = config.name;
        this.options = config.options;
        if (verify.isObject(config.model)) {
            this.modelInfo = new ModelInfo(config.model);
            this.contextInfos = null;
        }
        else {
            this.contextInfos = [];
            var i, i_len=config.contexts.length, item;
            for (i=0; i<i_len; i++) {
                item = config.contexts[i];
                this.contextInfos.push(new ModelInfo(item));
            }
            this.modelInfo = null;
        }
        this.isWfJob = config.isWfJob;
        this.transformers = config.transformers;
        this.gen = config.gen;
        this.dest = config.dest;
        this.wfjob = config.wfjob;
        this.genWriters = [];
    }
    ArtifactInfo.prototype.initialize = function(productionManager) {
        this.productionManager = productionManager;
        if (this.modelInfo) {
            this.modelInfo.productionManager(productionManager);
        }
        else {
            var i, i_len=this.contextInfos.length, item;
            for (i=0; i<i_len; i++) {
                item = this.contextInfos[i];
                item.productionManager(productionManager);
            }
        }
        this.options = _.merge({}, productionManager.options || {}, this.options || {})
        ;
    }
    ArtifactInfo.prototype.addGenWriter = function(ctx) {
        this.genWriters.push(ctx);
    }
    ArtifactInfo.prototype.isWizziFactoryJob = function() {
        return this.modelInfo != null && this.modelInfo.getContextCollectionInfo() == null && this.isWfJob;
    }
    ArtifactInfo.prototype.isWizziModelArtifact = function() {
        return this.modelInfo != null && this.modelInfo.getContextCollectionInfo() == null && verify.isObject(this.gen) && verify.isNotEmpty(this.gen.generator);
    }
    ArtifactInfo.prototype.isWizziCollectionArtifact = function() {
        return this.modelInfo != null && verify.isObject(this.modelInfo.getContextCollectionInfo()) && verify.isObject(this.gen);
    }
    ArtifactInfo.prototype.isCodeWriteArtifact = function() {
        return this.modelInfo == null && verify.isObject(this.gen) && verify.isNotEmpty(this.gen.generator);
    }
    ArtifactInfo.prototype.isFinalArtifact = function() {
        return this.modelInfo != null && (verify.isObject(this.gen) === false || verify.isEmpty(this.gen.generator));
    }
    ArtifactInfo.prototype.getItemsToPersistToFile = function(callback) {
        var check = {};
        var items = [];
        var i, i_len=this.genWriters.length, genWriter;
        for (i=0; i<i_len; i++) {
            genWriter = this.genWriters[i];
            var srcPath = genWriter.srcPath;
            if (this.isWizziCollectionArtifact()) {
                var collectionItem = genWriter.model;
                assert.strictEqual(verify.isObject(collectionItem), true, 'genWriter.model must contain an object.');
                var ipcontext = this.getInterpolatePathNameContext(collectionItem);
                if (ipcontext && ipcontext.__is_error) {
                    console.log('__is_error ', ipcontext);
                    return callback(ipcontext);
                }
                var destUri = this.getDestinationUri(srcPath);
                if (destUri && destUri.__is_error) {
                    console.log('__is_error ', destUri);
                    return callback(destUri);
                }
                var filepath = interpolate(destUri, ipcontext, {
                    delimiter: '{}'
                })
                ;
                logme('ArtifactInfo.getItemsToPersistToFile.ipcontext', ipcontext, 'filepath', filepath);
                if (check[filepath]) {
                    return this.error("Duplicated destination filepath: " + filepath, "getItemsToPersistToFile")
                    ;
                }
                check[filepath] = true;
                var persisteable = {
                    artifactInfo: this, 
                    genWriter: genWriter, 
                    filepath: filepath
                };
                items.push(persisteable);
            }
            else {
                var destUri = this.getDestinationUri(srcPath);
                if (destUri && destUri.__is_error) {
                    console.log('__is_error ', destUri);
                    return callback(destUri);
                }
                var persisteable = {
                    artifactInfo: this, 
                    genWriter: genWriter, 
                    filepath: destUri
                };
                items.push(persisteable);
            }
        }
        callback(null, items);
    }
    ArtifactInfo.prototype.getInterpolatePathNameContext = function(collectionItem) {
        if (this.isWizziCollectionArtifact()) {
            var result = {};
            var info = this.modelInfo.getContextCollectionInfo();
            var i, i_len=info.pathTemplateValues.length, templValue;
            for (i=0; i<i_len; i++) {
                templValue = info.pathTemplateValues[i];
                if (templValue.function) {
                    result[templValue.token] = collectionItem[templValue.function]();
                    if (verify.isEmpty(result[templValue.token])) {
                        return this.error('the path template value function must return a not empty string for token: "' + templValue.token + '"', 'getInterpolatePathNameContext')
                        ;
                    }
                }
                else if (templValue.attribute) {
                    result[templValue.token] = collectionItem[templValue.attribute];
                    logme('result[templValue.token]', result[templValue.token], verify.isEmpty(result[templValue.token])
                    );
                    if (verify.isEmpty(result[templValue.token])) {
                        return this.error('the path template value attribute "' + templValue.attribute + '" must return a not empty string for token: "' + templValue.token + '"', 'getInterpolatePathNameContext')
                        ;
                    }
                }
                else {
                    return this.error('path template value must contain an attribute or a function value for token: "' + templValue.token + '"', 'getInterpolatePathNameContext')
                    ;
                }
            }
            return result;
        }
        else {
            return this.error("Method called on an artifact that is not a wizzi collection artifact.", 'getInterpolatePathNameContext')
            ;
        }
    }
    ArtifactInfo.prototype.getDestinationUri = function(srcPath) {
        var dest = this.dest;
        var opt = this.options;
        var msg = [
            'ArtifactInfo.getDestinationUri', 
            'config.dest'
        ];
        if (verify.isNotEmpty(dest.fullpath)) {
            return dest.fullpath;
        }
        if (verify.isEmpty(dest.folder)) {
            return this.error('A not empty dest.folder is required', 'getDestinationUri')
            ;
        }
        var destpath;
        if (dest.path && verify.isAbsolutePath(dest.path)) {
            destpath = path.join(dest.path, srcPath);
        }
        else {
            srcPath = dest.path ? dest.path : srcPath;
            if (verify.isEmpty(srcPath)) {
                return this.error('A not empty srcPath is required', 'getDestinationUri')
                ;
            }
            destpath = path.join(dest.folder, srcPath);
        }
        if (this.isFinalArtifact() === false) {
            var ext;
            if (dest.extension === '@@null') {
                ext = "";
            }
            else {
                var ext = (dest.extension || '.js');
                ext = verify.startsWith(ext, '.') ? ext : ('.' + ext);
                if (ext.toLowerCase() !== '.ittf') {
                    if (destpath.substr(- (5), 5).toLowerCase() === '.ittf') {
                        destpath = destpath.substr(0, (destpath.length - 5));
                    }
                }
                ext = verify.endsWith(destpath, ext) ? '' : this.options.dotgExtensionPrefix ? ('.g' + ext) : ext;
            }
            destpath = (destpath + ext);
        }
        else {
            if (destpath.indexOf('__copy') >= 0) {
                destpath = verify.replaceAll(destpath, '__copy', '');
            }
        }
        if (verify.isAbsolutePath(destpath)) {
            return destpath;
        }
        if (verify.isEmpty(dest.baseFolder)) {
            return this.error('When dest.folder is a relative path, a not empty dest.baseFolder value is required.', 'getDestinationUri')
            ;
        }
        return path.join(dest.baseFolder, destpath)
        ;
    }
    ArtifactInfo.prototype.error = function(message,method) {
        var err = {
            __is_error: true, 
            message: message, 
            source: "wizzi/lib/production/artifactinfo.js/" + method, 
            modelInfo: this.modelInfo
        };
        logme(err);
        return err;
    }
    ArtifactInfo.prototype.dump = function() {
        throw new Error('Not implemented');
    }
    ArtifactInfo.prototype.relPath = function() {
        if (this.modelInfo) {
            return this.modelInfo.srcFullPath().substr(this.options.basedir.length + 1)
            ;
        }
        else {
            return 'null';
        }
    }
    ArtifactInfo.prototype.toString = function() {
        return [
                '\n', 
                'ArtifactInfo ', 
                'name:', 
                this.name(), 
                'model.src:', 
                this.relPath(), 
                ', gen.generator:', 
                this.gen ? this.gen.generator : 'none', 
                '\n'
            ].join(' ');
    }
    ArtifactInfo.prototype.terminate = function() {
        if (this.modelInfo) {
            this.modelInfo.terminate();
        }
        if (this.contextInfos) {
            var i, i_len=this.contextInfos.length, item;
            for (i=0; i<i_len; i++) {
                item = this.contextInfos[i];
                item.terminate();
            }
        }
        if (this.genWriters) {
            var i, i_len=this.genWriters.length, item;
            for (i=0; i<i_len; i++) {
                item = this.genWriters[i];
                item.terminate();
            }
        }
    }
    ArtifactInfo.isArtifactConfig = function(test) {
        if (!test) {
            return false;
        }
        if (!verify.isObject(test.options)) {
            return false;
        }
        if (!verify.isObject(test.model) && !verify.isObject(test.contexts)) {
            return false;
        }
        if (!verify.isObject(test.dest)) {
            return false;
        }
        if (!verify.isObject(test.gen)) {
            return false;
        }
        return true;
    }
    ArtifactInfo.isArtifactInstance = function(test) {
        throw new Error('Not implemented');
    }
    return ArtifactInfo;
})();

module.exports = {
    ArtifactInfo: ArtifactInfo
};
