var md = module.exports = {};
md.isDescendentOf = function (model, ancestor) {
    if (!model.wzParent) return false;
    if (model.wzParent.wzElement == ancestor) return true;
    return md.isDescendentOf(model.wzParent, ancestor);
}
md.isTopStatement = function (model) {
    if (!model.wzParent) return true;
    var prnElement = model.wzParent.wzElement;
    // if (prnElement === 'else' && model.wzParent.wzParent && model.wzParent.wzParent.wzElement === 'iif') return false;
    return ['xfunction', 'arrowfunction', 'ctor', 'method',
        'module', 'ready', 'html_f',
        'html_dom', 'html_hb', 'block',
        'xfor', 'foreach', 'xwhile',
        'xdo', 'xif', 'xelse',
        'elif', 'xtry', 'xfinally',
        'xcatch', 'xcase', 'xdefault',
        'describe', 'it', 'before',
        'itAsync', 'beforeAsync', 'afterAsync',
        'beforeEach', 'after', 'afterEach', 'xlabel',
        'wzIife', 'wzFunction',
        '_js', '_css' // TODO this is an hack to make the html/document artifact work,
                      // how to inject this ???
                      // Or : we are inside the same wizziFactoryPackage, who cares?  
    ].indexOf(prnElement) > -1;
}
md.isDeclare = function (model) {
    if (!model.wzParent) return false;
    return ['xvar']
        .indexOf(model.wzParent.wzElement) > -1;
}
md.isObjectProperty = function (model) {
    if (!model.wzParent) return false;
    return ['jsObject'].indexOf(model.wzParent.wzElement) > -1;
}
md.isMemberAccess = function (model) {
    if (['memberAccess', 'memberAccessComputed', 'memberCall', 'decoratorCall',
        'callOnValue'].indexOf(model.wzElement) > -1) return true;
}
md.isMemberAccessOrCall = function (model) {
    if (['memberAccess', 'memberAccessComputed', 'memberCall', 'decoratorCall',
        'callOnValue'].indexOf(model.wzElement) > -1) return true;
    if (!model.wzParent) return false;
    if (model.wzElement === 'call' && model.wzParent.wzElement === 'call') return true;
    return false;
}
md.isCallArgument = function (model) {
    return (model.wzElement === 'call' && model.wzParent && model.wzParent.wzElement === 'call');
}
md.isArgumentOfCall = function (model) {
    return model.wzParent && ['call', 'memberCall', 'decoratorCall', 'callOnValue'].indexOf(model.wzParent.wzElement) >= 0;
}
md.onlyChildIs = function (model, element) {
    return model.statements && model.statements.length == 1 && model.statements[0].wzElement === element;
}
md.parentIs = function (model, element) {
    return model.wzParent && model.wzParent.wzElement === element;
}
md.parentIsHtmlElement = function (model) {
    if (!model.wzParent) return false;
    return [
        'htmlelement',
	    'a',
	    'br',
	    'button',
	    'div',
	    'form',
	    'h1',
	    'h2',
	    'h3',
	    'h4',
	    'i',
	    'img',
	    'input',
	    'label',
	    'legend',
	    'li',
	    'option',
	    'p',
	    'select',
	    'span',
	    'table',
	    'tbody',
	    'td',
	    'textarea',
	    'th',
	    'thead',
	    'tr',
	    'ul'].indexOf(model.wzParent.wzElement) > -1;
}
md.isValue = function (model) {
    if (!model.wzParent) return false;
    return ['jsArray', 'jsPropertyOrValue', 'memberAccessComputed', 'or', 'and']
        .indexOf(model.wzParent.wzElement) > -1;
}
md.isParamValue = function (model) {
    if (!model.wzParent) return false;
    // these entities can be passed as param to call ( _ ) and memberCall ( ._ )
    return ['call', 'memberCall', 'decoratorCall', 'callOnValue', 'iife', 'xnew']
        .indexOf(model.wzParent.wzElement) > -1;
}
md.semicolon = function (text) {
    return text && text.length ? (text[text.length - 1] === ';' ? '' : ';') : ';';
}
md.unparen = function (text) {
    if (typeof text !== 'string') return text;
    var s = text.trim();
    return md.isParenEnclosed(s) ? s.substr(1, s.length - 2) : text;
}
md.setOperator = function (text, statements) {
    if (!(text && text.length)) return '';
    text = text.trim();
    if (statements.length === 1 && statements[0].wzElement === 'memberAccessComputed') return text + '';
    var t1 = text.substr(-1, 1);
    var t2 = text.substr(-2, 2);
    if (op1.indexOf(t1) > -1) return text + ' ';
    if (op2.indexOf(t2) > -1) return text + ' ';
    return text + ' = ';
}
md.encloseParen = function (text) {
    var s = text.trim();
    if (md.isParenEnclosed(s) === false) {
        if (s.substr(0, 1) !== '(') s = '(' + s;
        if (s.substr(-1, 1) !== ')') s = s + ')';
        return s;
    } else {
        return text;
    }
}
md.isParenEnclosed = function (name) {
    if (typeof name !== 'string') return false;
    name = name.trim();
    var hasEndParens = name.substr(-1, 1) === ')' ||
                       name.substr(-2, 2) === ');';
    if (!hasEndParens || name.substr(0, 1) !== '(') return false;
    var count = 1, quote = null;
    for (var ch, i = 1; i < name.length; i++) {
        ch = name[i];
        if (ch === '"' || ch === "'") {
            if (quote === ch) quote = null;
            else if (quote === null) quote = ch;
        }
        else if (quote !== null) {
                ;
        }
        else if (ch === '(') {
            count++;
        } else if (ch === ')') {
            count--;
        }
        if (i < (name.length - 1) && count === 0) {
            return false;
        }
    }
    return true;
}
md.isQuoted = function (name) {
    if (typeof name !== 'string' || name.length < 2) return false;
    return name.substr(0, 1) === '"' && name.substr(-1, 1) === '"' ||
           name.substr(0, 1) === '\'' && name.substr(-1, 1) === '\''
}
//TODO complete
var op1 = ['='];
var op2 = ['+=', '-=', '/=', '*='];
var parenOp = ['||', '>>>', '>>'];
md.getOpenParen = function (oper) {
    return parenOp.indexOf(oper) > -1 ? '(' : '';
}
md.getCloseParen = function (oper) {
    return parenOp.indexOf(oper) > -1 ? ')' : '';
}
md.getParentOfType = function (model, type) {
    var prn = model.wzParent;
    while (prn != null && prn.wzElement !== type)
        prn = prn.wzParent;
    return prn;
}
md.hasArguments = function (callText) {
    if (typeof callText !== 'string') return false;
    callText = callText.trim();
    var hasEndParens = callText.substr(-1, 1) === ')' ||
                       callText.substr(-2, 2) === ');';
    if (!hasEndParens) return false;
    var namecount = 0
    var enclosedcount = 0
    var seen = false;
    var count = 0, quote = null;
    for (var ch, i = 0; i < callText.length; i++) {
        ch = callText[i];
        if (ch === '"' || ch === "'") {
            if (quote === ch) quote = null;
            else if (quote === null) quote = ch;
        }
        else if (quote !== null) {
                ;
        }
        else if (ch === '(') {
            seen = true;
            count++;
        } else if (ch === ')') {
            count--;
            if (count === 0) enclosedcount++;
        } else if (!seen) {
            namecount++;
        }
    }
    return seen && (namecount > 0 || enclosedcount > 1) && count == 0;
}
md.emitBlock = function (cnt, tag, model, items, count, ctx) {
    // console.log('ctx.values.__preserveBlock', ctx.values.__preserveBlock, items.length);
    var blockIndex = items.length > 0 && items[0].wzElement === 'test' ? 1 : 0;
    if (ctx.values.__preserveBlock) {
        if (count > blockIndex && items[blockIndex].wzElement === 'block') {
            if (tag === 'case')
                ctx.w(tag + ' ' + model.wzName + ': {');
            else if (tag === 'else')
                ctx.w(tag + ' {');
            else
                md.emitTest(cnt, tag, model, items, ctx, ' {');
        } else {
            if (tag === 'case')
                ctx.w(tag + ' ' + model.wzName + ':');
            else if (tag === 'else')
                ctx.w(tag);
            else
                md.emitTest(cnt, tag, model, items, ctx, '');
        }
    } else {
        if (tag === 'case')
            ctx.w(tag + ' ' + model.wzName + ': {');
        else if (tag === 'else')
            ctx.w(tag + ' {');
        else
            md.emitTest(cnt, tag, model, items, ctx, ' {');
    }
    if (items.length > 0 && items[0].wzElement === 'test')
        cnt.genItems(items, ctx, { indent: true, from: 1 });
    else
        cnt.genItems(items, ctx, { indent: true });
    if (ctx.values.__preserveBlock) {
        if (count > blockIndex && items[blockIndex].wzElement === 'block') {
            ctx.w('}');
        }
    } else {
        ctx.w('}');
    }
}
md.emitTest = function (cnt, tag, model, items, ctx, open) {
    if (items.length > 0 && items[0].wzElement === 'test') {
        ctx.write(tag + ' ');
        cnt.genItem(items[0], ctx);
        ctx.w(open);
    } else {
        ctx.w(tag + ' (' + md.unparen(model.wzName) + ')' + open);
    }
}
