/*
    artifact generator: /wizzi/lib/artifacts/js/module/gen/main.js
    primary source IttfDocument: C:\My\wizzi\v2\sources\wizzi-2-boot\ittf\lib\esprima\jsScriptCoder.js.ittf
    utc time: Tue, 11 Jul 2017 18:50:00 GMT
*/
'use strict';
// generated by js.module.es2015.module
function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }
var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var JsScriptCoder = (function () {
    function JsScriptCoder() {
        _classCallCheck(this, JsScriptCoder);
        this.stm = [];
        this.indentValue = 0;
        this.length = 0;
        this.line = '';
    }
    JsScriptCoder.prototype.for = function(text,node) {
        if (this.line.length > 0) {
            this.w();
        }
        this.w('for (' + text + ') {' + ' //' + node.id);
        this.indent();
    }
    JsScriptCoder.prototype.if = function(text,node) {
        if (this.line.length > 0) {
            this.w();
        }
        this.w('if (' + text + ') {' + ' //' + node.id);
        this.indent();
    }
    JsScriptCoder.prototype.elif = function(text,node) {
        if (this.line.length > 0) {
            this.w();
        }
        this.w('else if (' + text + ') {' + ' //' + node.id);
        this.indent();
    }
    JsScriptCoder.prototype.else = function() {
        if (this.line.length > 0) {
            this.w();
        }
        this.w('else {');
        this.indent();
    }
    JsScriptCoder.prototype.while = function(text,node) {
        if (this.line.length > 0) {
            this.w();
        }
        this.w('while (' + text + ') {' + ' //' + node.id);
        this.indent();
    }
    JsScriptCoder.prototype.end = function() {
        if (this.line.length > 0) {
            this.w();
        }
        this.deindent();
        this.w('}');
    }
    JsScriptCoder.prototype.w = function(text) {
        var ind = spaces(this.indentValue * 4);
        this.stm.push(ind + this.line + (text || ''));
        this.line = '';
        this.length++;
    }
    JsScriptCoder.prototype.write = function(text) {
        this.line += (text || '');
    }
    JsScriptCoder.prototype.indent = function() {
        this.indentValue++;
    }
    JsScriptCoder.prototype.deindent = function() {
        this.indentValue = Math.max(0, (this.indentValue - 1));
    }
    JsScriptCoder.prototype.toCode = function() {
        if (this.line.length > 0) {
            this.w();
        }
        return this.stm.join('\n');
    }
    JsScriptCoder.prototype.getErrorLines = function(esprimaException) {
        var start = Math.max(0, (esprimaException.lineNumber - 4));
        var end = Math.min(this.stm.length, (esprimaException.lineNumber + 4))
        ;
        var ret = [];
        for (var i = start; i < end; i++) {
            ret.push(formatLineNumber(i + 1) + ' ' + this.stm[i]);
            if (i == esprimaException.lineNumber - 1) {
                var col = esprimaException.column;
                ret.push(spaces(col + 4) + '* ' + esprimaException.description);
            }
        }
        return ret;
    }
    return JsScriptCoder;
})();


function spaces(num) {
    return Array(num + 1).join(" ");
}

function formatLineNumber(num) {
    if (num > 999) {
        return num;
    }
    if (num > 99) {
        return ('0' + num);
    }
    if (num > 9) {
        return ('00' + num);
    }
    return ('000' + num);
}

module.exports = JsScriptCoder;
