/*
    artifact generator: /wizzi/lib/artifacts/js/module/gen/main.js
    primary source IttfDocument: C:\My\wizzi\v2\sources\wizzi-2-boot\ittf\lib\ittf\repo\repoStore.js.ittf
    utc time: Tue, 11 Jul 2017 18:50:00 GMT
*/
'use strict';
// generated by js.module.es2015.module
function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }
var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var util = require('util');
var errors = require('./errors'),
    uriparser = require('../fs/uriparser');
var RepoStore = (function () {
    function RepoStore() {
        _classCallCheck(this, RepoStore);
        this.storeKind = 'repo';
    }
    RepoStore.prototype.init = function(callback) {
        this.wizziMongoDb_FS = require('wizzi-mongodb').Filesystem;
        if (this.wizziMongoDb_FS.isMounted == false) {
            var error = new errors.RepoIOError('MongoDB wizzi repo database not mounted. Review your wizzi instance starter.', '');
        }
        else {
            // log 'lib/ittf/repo/repoStore.init OK'
            callback(null);
        }
    }
    RepoStore.prototype.documentExists = function(documentPath,callback) {
        var that = this;
        uriparser(documentPath, function(err,parsedPath) {
            if (err) {
                return callback(err)
                ;
            }
            that.wizziMongoDb_FS.isFile(parsedPath.userId, parsedPath.projectId, parsedPath.path, function(err,result) {
                if (err) {
                    var error = new errors.RepoIOError(util.inspect(err, {depth: null}) + '\nChecking documentExists', documentPath);
                    return callback(error);
                }
                callback(null, result);
            });
        });
    }
    RepoStore.prototype.getModelContent = function(documentPath,callback) {
        var that = this;
        uriparser(documentPath, function(err,parsedPath) {
            if (err) {
                return callback(err)
                ;
            }
            that.wizziMongoDb_FS.readFile(parsedPath.userId, parsedPath.projectId, parsedPath.path, function(err,result) {
                if (err) {
                    var error = new errors.RepoIOError(util.inspect(err, {
                        depth: null
                    })
                    , documentPath);
                    return callback(error);
                }
                // log 'getModelContent.received', result
                return callback(null, result);
            });
        });
    }
    return RepoStore;
})();


module.exports = RepoStore;
