/*
    artifact generator: /wizzi/lib/artifacts/js/module/gen/main.js
    primary source IttfDocument: C:\My\wizzi\v2\sources\wizzi-2-boot\ittf\lib\production\manager.js.ittf
    utc time: Tue, 11 Jul 2017 18:50:00 GMT
*/
'use strict';
// generated by js.module.es2015.module
function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }
var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var path = require('path');
var util = require('util');
var async = require('async');
var verify = require('../util/verify');
var file = require('../util/file');
var fail = require('../util/fail');
var ittf = require('../ittf/ittf');
var GenWriter = require('../artifact/GenWriter');
var StringWriter = require('../util/stringwriter');
var log = require('../util/log')(module);
var options = require('./options');
var ProductionContext = require("./context").ProductionContext;
var ArtifactInfo = require('../artifact/artifactinfo').ArtifactInfo;
var pkgLoader = require('./wfpackageloader');
var Runner = require('./runner').Runner;
var WfJob = require('./wfjob');
var ArtifactPersister = require('./persister').ArtifactPersister;
var thisWizziPackage = require('../../index');
// var legacy = require('../../legacy')
var Repository = require('../services/repository');
// var Logger = require('../services/logger')
/**
     registerWizziFactoryPackage(wizziModule)
     addArtifactInfo(artifactInfo)
     addWfJob(wfJobConfig)
     getWizziModelFactory(schemaName)
     getWizziSchemaObject(schemaName)
     getModelTransformer(transName)
     getArtifactGenerator(artifactName)
     run:AsyncMethod
     persistToFile:AsyncMethod
    
     You execute a production
     first registering wizzi packages
     then adding wfjobs and/or artifact infos
     finally executing the run and persistToFile async methods
    
*/
var ProductionManager = (function () {
    function ProductionManager(options) {
        _classCallCheck(this, ProductionManager);
        this.options = options;
        this.artifactInfos = [];
        this.wfJobArtifactInfos = [];
        this.wfJobConfigs = [];
        this.repository = new Repository();
        this.repository.registerWizziFactoryPackage(thisWizziPackage);
        // _ this.repository.registerWizziFactoryPackage(legacy)
        this.productionContext = new ProductionContext();
        log.setLevel(options.verbose || 0);
        this.___state = {
            models: {}, 
            pman: this, 
            pcx: this.productionContext
        };
        // set this.logger = new Logger()
        this.productionName = 'production';
    }
    /**
         param options {
         verbose:Boolean
         trace:Boolean
         basedir:String // uri
         }
    */
    /**
         Add an artifact info declared in a "artifact" element of a "wfjob" WizziModel.
         It may also be built programmatically.
    */
    ProductionManager.prototype.addArtifactInfo = function(artifactInfoConfig) {
        if (ArtifactInfo.isArtifactConfig(artifactInfoConfig)) {
            this.artifactInfos.push(new ArtifactInfo(artifactInfoConfig));
        }
        else if (ArtifactInfo.isArtifactInstance(artifactInfoConfig)) {
            this.artifactInfos.push(artifactInfoConfig);
        }
        else {
            throw new Error('ProductionManager.addArtifactInfo is not an artifact info: ' + util.inspect(artifactInfoConfig));
        }
    }
    /**
         Add a WfJob request declared in an "artifact" element of a "wfjob" WizziModel.
    */
    ProductionManager.prototype.addWfJobArtifactInfo = function(wfJobArtifactInfoConfig) {
        this.wfJobArtifactInfos.push(new ArtifactInfo(wfJobArtifactInfoConfig));
    }
    ProductionManager.prototype.addWfJob = function(wfJobConfig) {
        wfJobConfig.__pman = this;
        wfJobConfig.options = Object.assign({}, this.options, (wfJobConfig.options || {}));
        this.wfJobConfigs.push(wfJobConfig);
    }
    ProductionManager.prototype.registerWizziFactoryPackage = function(wizziModule) {
        this.repository.registerWizziFactoryPackage(wizziModule);
    }
    ProductionManager.prototype.getWizziModelFactory = function(schemaName) {
        if (schemaName === 'ittf') {
            return function(ittfDocument,context,callback) {
                    if (!ittf.load) {
                        ittf = require('../ittf/ittf');
                    }
                    ittf.load(ittfDocument, context, function(err,ittfModel) {
                        if (err) {
                            return callback(err);
                        }
                        return callback(null, ittfModel.nodes[0]);
                    });
                };
        }
        else {
            return this.repository.getWizziModelFactory(schemaName);
        }
    }
    ProductionManager.prototype.getWizziSchemaObject = function(schemaName) {
        return this.repository.getWizziSchemaObject(schemaName);
    }
    ProductionManager.prototype.getModelTransformer = function(transName) {
        return this.repository.getModelTransformer(transName);
    }
    ProductionManager.prototype.getArtifactGenerator = function(artifactName) {
        return this.repository.getArtifactGenerator(artifactName);
    }
    ProductionManager.prototype.initialize = function(callback) {
        log.info('Initialize');
        async.map(this.wfJobConfigs, AsyncInitializeArtifactInfo.run, function(err,notUsed) {
            if (err) {
                return callback(err)
                ;
            }
            callback(null, null);
        });
    }
    ProductionManager.prototype.run = function(callback) {
        log.info('Start run');
        var self = this;
        this.initialize(function(err,nullResult) {
            if (err) {
                return callback(err)
                ;
            }
            async.map(self.wfJobArtifactInfos, AsyncRunner.run, function(err,result) {
                if (err) {
                    return callback(err)
                    ;
                }
                async.map(self.artifactInfos, AsyncRunner.run, function(err,result) {
                    if (err) {
                        return callback(err);
                    }
                    self.artifactInfos = result;
                    self.terminate();
                    log.info('End run');
                    callback(null, result);
                });
            });
        });
    }
    ProductionManager.prototype.terminate = function() {
        log.info('Terminate');
    }
    ProductionManager.prototype.persistToFile = function(callback) {
        log.info('Start persistToFile');
        var self = this;
        async.map(self.artifactInfos, AsyncPersisterToFile.run, function(err,result) {
            if (err) {
                return callback(err);
            }
            // log 'ProductionManager.persistToFile.persisted artifacts', util.inspect(result, { depth: 1 })
            var i, i_len=self.artifactInfos.length, ai;
            for (i=0; i<i_len; i++) {
                ai = self.artifactInfos[i];
                ai.terminate();
            }
            log.info('End persistToFile');
            callback(null, result);
        });
    }
    ProductionManager.prototype.relPath = function(filepath) {
        return filepath.substr(this.options.basedir.length + 1);
    }
    ProductionManager.prototype.aclStat = function(value) {
        if (typeof(value) === 'undefined') {
            return this.aclStatObject;
        }
        else {
            this.aclStatObject = value;
            this.productionContext.setAclStat(value);
        }
    }
    ProductionManager.prototype.globalContext = function(value) {
        if (typeof(value) === 'undefined') {
            return this.globalContextObject || {};
        }
        else {
            this.globalContextObject = value;
        }
    }
    ProductionManager.prototype.setStateModel = function(key,value) {
        this.___state.models[key] = value;
    }
    ProductionManager.prototype.getLogState = function() {
        var logState = {
            models: {}
        };
        // log 'wizzi-factory/productionManager/state models length', this.___state.models.length
        for (var m in this.___state.models) {
            var mo = this.___state.models[m];
            var modelState = {};
            logState[m] = modelState;
            for (var k in mo) {
                // log 'wizzi-factory/productionManager/state model prop', k
                if (mo.loadContext) {
                    modelState.ittfSources = mo.loadContext.getIttfDocuments();
                    var i, i_len=mo.loadContext.ittfDocumentDatas.length, idm;
                    for (i=0; i<i_len; i++) {
                        idm = mo.loadContext.ittfDocumentDatas[i];
                        var idm_o = mo.loadContext.ittfDocumentDatas[idm];
                        delete idm_o.ittfModel
                        for (var idm_k in idm_o) {
                            // log 'wizzi-factory/productionManager/state model loadContext ittfDocumentData prop', idm_k
                        }
                    }
                    // set modelState.ittfDocumentDatas = mo.loadContext.ittfDocumentDatas
                    for (var z in mo.loadContext) {
                        // log 'wizzi-factory/productionManager/state model loadContext prop', z
                    }
                    if (mo.loadContext.ittfSources) {
                        for (var z in mo.loadContext.ittfSources) {
                            // log 'wizzi-factory/productionManager/state model ittfSources prop', z
                        }
                    }
                }
            }
        }
        return logState;
    }
    ProductionManager.prototype.go_generateArtifact = function(artifactName,artifactContext,wizziModelInstance,callback) {
        var self = this;
        var generator = this.getArtifactGenerator(artifactName);
        if (generator == null) {
            var msg = 'ProductionManager.go_generateArtifact cannot find generator for artifact: ' + artifactName;
            fail.warn(msg);
            throw new Error(msg);
        }
        var genWriter = new GenWriter({ options: options(null, { data: artifactContext.__data }) });
        new generator.gen(wizziModelInstance, genWriter, function(err) {
            if (err) {
                var msg = util.inspect(err, { depth: null});
                fail.warn(msg);
                throw new Error(msg);
            }
            var sw = new StringWriter();
            genWriter.toStream(sw);
            callback(null, sw.toString());
        });
    }
    ProductionManager.prototype.generateArtifact = function(schemaName,artifactName,ittfDocumentUri,modelContext,artifactContext,callback) {
        var self = this;
        var factory = this.getWizziModelFactory(schemaName);
        if (factory == null) {
            var msg = 'ProductionManager.generateArtifact cannot find factory for schema: ' + schemaName + ' for artifact ' + ittfDocumentUri;
            fail.warn(msg);
            throw new Error(msg);
        }
        if (!factory.load) {
            if (schemaName == 'ittf') {
                factory(ittfDocumentUri, modelContext, function(err,wizziModelInstance) {
                    if (err) {
                        var msg = 'Error loading IttfDocument: ' + ittfDocumentUri + '\n' + util.inspect(err, { depth: null});
                        fail.warn(msg);
                        throw new Error(msg);
                    }
                    self.go_generateArtifact(artifactName, artifactContext, wizziModelInstance, callback);
                });
                return ;
            }
            else {
                var msg = 'ProductionManager.generateArtifact. Missing load method in factory for schema: ' + schemaName + ' for artifact ' + ittfDocumentUri;
                fail.warn(msg);
                throw new Error(msg);
            }
        }
        else {
            factory.load(ittfDocumentUri, modelContext, function(err,wizziModelInstance) {
                // log 'ProductionManager.generateArtifact', err
                if (err) {
                    var msg = 'Error loading IttfDocument: ' + ittfDocumentUri + '\n' + util.inspect(err, { depth: null});
                    fail.warn(msg);
                    throw new Error(msg);
                }
                self.go_generateArtifact(artifactName, artifactContext, wizziModelInstance, callback);
            });
        }
    }
    return ProductionManager;
})();


var AsyncInitializeArtifactInfo = {
    run: function(jobConfig,callback) {
        var pman = jobConfig.__pman;
        var wfjobSrc = jobConfig.wfjob.src;
        // log 'pman.productionName, wfjobSrc', pman.productionName, wfjobSrc
        pman.productionName += '_' + path.basename(wfjobSrc);
        // log 'pman.productionName formatted', pman.productionName
        var job = new WfJob(pman, jobConfig);
        job.getArtifactInfoConfigs(function(err,result) {
            if (err) {
                return callback(err)
                ;
            }
            var requires = result[0];
            // log 'requires', requires
            var i, i_len=requires.length, r;
            for (i=0; i<i_len; i++) {
                r = requires[i];
                var factoryPackage = pkgLoader.load(r, path.dirname(wfjobSrc));
                pman.registerWizziFactoryPackage(factoryPackage);
            }
            var artifactInfoConfigs = result[1];
            var i, i_len=artifactInfoConfigs.length, artifactInfoConfig;
            for (i=0; i<i_len; i++) {
                artifactInfoConfig = artifactInfoConfigs[i];
                // log 'ProductionManager.initialize.artifactInfoConfig', util.inspect(artifactInfoConfig, { depth: 2 })
                artifactInfoConfig.wfjob = wfjobSrc;
                if (pman.options.trace) {
                    console.log('ProductionManager.initialize.artifactInfoConfig', artifactInfoConfig.toString());
                }
                if (artifactInfoConfig.isWfJob) {
                    console.log('ProductionManager.initialize.artifactInfoConfig', "isWfJob", inspect(artifactInfoConfig, { depth: 2 }));
                    pman.addWfJobArtifactInfo(artifactInfoConfig);
                }
                else {
                    pman.addArtifactInfo(artifactInfoConfig);
                }
            }
            var i, i_len=pman.wfJobArtifactInfos.length, artifactInfo;
            for (i=0; i<i_len; i++) {
                artifactInfo = pman.wfJobArtifactInfos[i];
                artifactInfo.initialize(pman);
            }
            var i, i_len=pman.artifactInfos.length, artifactInfo;
            for (i=0; i<i_len; i++) {
                artifactInfo = pman.artifactInfos[i];
                artifactInfo.initialize(pman);
            }
            callback(null, null);
        });
    }
};
/**
    async run an artifact production
     from an artifactInfo object
*/
var AsyncRunner = {
    run: function(artifactInfo,callback) {
        log.info('Started async run artifact: ' + artifactInfo.name);
        var runner = new Runner(artifactInfo);
        runner.run(function(err,operResult) {
            if (err) {
                return callback(err)
                ;
            }
            log.info('Ended async run artifact: ' + artifactInfo.name);
            callback(null, operResult);
        });
    }
};
/**
    async persist one or more artifact productions
     from an artifactInfo object.
     uses an ArtifactPersister instance
*/
var AsyncPersisterToFile = {
    run: function(artifactInfo,callback) {
        if (!artifactInfo.productionManager) {
            log.error('AsyncPersisterToFile. Invalid artifactInfo:', artifactInfo);
            callback(artifactInfo);
        }
        log.info('Started async persist to file artifact: ' + artifactInfo.name);
        var persister = new ArtifactPersister(artifactInfo);
        persister.toFile(function(err,operResult) {
            if (err) {
                return callback(err)
                ;
            }
            var i, i_len=operResult.length, oper;
            for (i=0; i<i_len; i++) {
                oper = operResult[i];
                log.info(oper.oper + ', ' + oper.status + ', ' + oper.item.filepath);
            }
            log.info('Ended async persist to file artifact: ' + artifactInfo.name);
            callback(null, operResult);
        });
    }
};
module.exports = ProductionManager;
